<?php
/***************************************************************************
                                digest_tables.php
                             -------------------
    begin                : Sat Oct 4 2003
    copyright            : (C) 2000 The phpBB Group
    email                : support@phpBB.com

    $Id: $

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

// Written by Mark D. Hamill, mhamill@computer.org
// This software is designed to work with phpBB Version 2.0.20

// This is a "run once" program that creates two tables needed for this modification. Make sure you have
// defined the names of the tables in the digest_constants include file. The include file needs to be 
// installed before this can be run.

// SQL works for MySQL. SQL may possibly need to be modified for other types of databases. 

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/digest_constants.' . $phpEx); 

$sql = 'CREATE TABLE ' . DIGEST_SUBSCRIPTIONS_TABLE . " (
	user_id smallint(8) NOT NULL default 0,
	digest_type enum('DAY','WEEK') NOT NULL default 'DAY',
	format enum('HTML','TEXT') NOT NULL default 'TEXT',
	show_text enum('YES','NO') NOT NULL default 'YES',
	show_mine enum('YES','NO') NOT NULL default 'YES',
	new_only enum('TRUE','FALSE') NOT NULL default 'TRUE',
	send_on_no_messages enum('YES','NO') NOT NULL default 'NO',
	send_hour tinyint(4) NOT NULL default 0,
	text_length int(11) NOT NULL default 0,
	PRIMARY KEY  (user_id),
	UNIQUE KEY user_id (user_id)
) TYPE=MyISAM COMMENT='Used to send out email'";

// create subscriptions table
if ( !($result = $db->sql_query($sql)))
		{
			message_die(GENERAL_ERROR, 'Unable to create '. DIGEST_SUBSCRIPTIONS_TABLE . ' table', '', __LINE__, __FILE__, $sql);
		}
$sql='CREATE TABLE ' . DIGEST_SUBSCRIBED_FORUMS_TABLE . " (
	user_id mediumint(8) NOT NULL default 0,
	forum_id smallint(5) NOT NULL default 0,
	UNIQUE KEY user_id (user_id,forum_id)
) TYPE=MyISAM COMMENT='Forums on which members want digests'";

// create subscriptions table
if ( !($result = $db->sql_query($sql)))
{
	message_die(GENERAL_ERROR, 'Unable to create '. DIGEST_SUBSCRIBED_FORUMS_TABLE . ' table', '', __LINE__, __FILE__, $sql);
}
?>
<html>
<head>
<title>Create Digest Tables</title>
</head>
<body>
All digest database tables successfully created!
</body>
</html>



